// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CollisionObject = require('./CollisionObject.js');

//-----------------------------------------------------------

class AttachedCollisionObject {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.link_name = null;
      this.object = null;
      this.touch_links = null;
    }
    else {
      if (initObj.hasOwnProperty('link_name')) {
        this.link_name = initObj.link_name
      }
      else {
        this.link_name = '';
      }
      if (initObj.hasOwnProperty('object')) {
        this.object = initObj.object
      }
      else {
        this.object = new CollisionObject();
      }
      if (initObj.hasOwnProperty('touch_links')) {
        this.touch_links = initObj.touch_links
      }
      else {
        this.touch_links = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AttachedCollisionObject
    // Serialize message field [link_name]
    bufferOffset = _serializer.string(obj.link_name, buffer, bufferOffset);
    // Serialize message field [object]
    bufferOffset = CollisionObject.serialize(obj.object, buffer, bufferOffset);
    // Serialize message field [touch_links]
    bufferOffset = _arraySerializer.string(obj.touch_links, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AttachedCollisionObject
    let len;
    let data = new AttachedCollisionObject(null);
    // Deserialize message field [link_name]
    data.link_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [object]
    data.object = CollisionObject.deserialize(buffer, bufferOffset);
    // Deserialize message field [touch_links]
    data.touch_links = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.link_name.length;
    length += CollisionObject.getMessageSize(object.object);
    object.touch_links.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/AttachedCollisionObject';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3fd8ca730863e3d97d109c317d106cf9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The CollisionObject will be attached with a fixed joint to this link
    # If link name is set to REMOVE_ALL_ATTACHED_OBJECTS and object.operation 
    # is set to REMOVE will remove all attached bodies attached to any object
    string link_name
    
    #Reserved for indicating that all attached objects should be removed
    string REMOVE_ALL_ATTACHED_OBJECTS = "all"
    
    #This contains the actual shapes and poses for the CollisionObject
    #to be attached to the link
    #If action is remove and no object.id is set, all objects
    #attached to the link indicated by link_name will be removed
    CollisionObject object
    
    # The set of links that the attached objects are allowed to touch
    # by default - the link_name is included by default
    string[] touch_links
    
    ================================================================================
    MSG: arm_navigation_msgs/CollisionObject
    # a header, used for interpreting the poses
    Header header
    
    # the id of the object
    string id
    
    # The padding used for filtering points near the object.
    # This does not affect collision checking for the object.  
    # Set to negative to get zero padding.
    float32 padding
    
    #This contains what is to be done with the object
    CollisionObjectOperation operation
    
    #the shapes associated with the object
    arm_navigation_msgs/Shape[] shapes
    
    #the poses associated with the shapes - will be transformed using the header
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: arm_navigation_msgs/CollisionObjectOperation
    #Puts the object into the environment
    #or updates the object if already added
    byte ADD=0
    
    #Removes the object from the environment entirely
    byte REMOVE=1
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes an attached object, detaches from the attached link
    #But adds back in as regular object
    byte DETACH_AND_ADD_AS_OBJECT=2
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes current object in the environment and removes it as
    #a regular object
    byte ATTACH_AND_REMOVE_AS_OBJECT=3
    
    # Byte code for operation
    byte operation
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AttachedCollisionObject(null);
    if (msg.link_name !== undefined) {
      resolved.link_name = msg.link_name;
    }
    else {
      resolved.link_name = ''
    }

    if (msg.object !== undefined) {
      resolved.object = CollisionObject.Resolve(msg.object)
    }
    else {
      resolved.object = new CollisionObject()
    }

    if (msg.touch_links !== undefined) {
      resolved.touch_links = msg.touch_links;
    }
    else {
      resolved.touch_links = []
    }

    return resolved;
    }
};

// Constants for message
AttachedCollisionObject.Constants = {
  REMOVE_ALL_ATTACHED_OBJECTS: '"all"',
}

module.exports = AttachedCollisionObject;
