// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let JointConstraint = require('./JointConstraint.js');
let PositionConstraint = require('./PositionConstraint.js');
let OrientationConstraint = require('./OrientationConstraint.js');
let VisibilityConstraint = require('./VisibilityConstraint.js');

//-----------------------------------------------------------

class Constraints {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.joint_constraints = null;
      this.position_constraints = null;
      this.orientation_constraints = null;
      this.visibility_constraints = null;
    }
    else {
      if (initObj.hasOwnProperty('joint_constraints')) {
        this.joint_constraints = initObj.joint_constraints
      }
      else {
        this.joint_constraints = [];
      }
      if (initObj.hasOwnProperty('position_constraints')) {
        this.position_constraints = initObj.position_constraints
      }
      else {
        this.position_constraints = [];
      }
      if (initObj.hasOwnProperty('orientation_constraints')) {
        this.orientation_constraints = initObj.orientation_constraints
      }
      else {
        this.orientation_constraints = [];
      }
      if (initObj.hasOwnProperty('visibility_constraints')) {
        this.visibility_constraints = initObj.visibility_constraints
      }
      else {
        this.visibility_constraints = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Constraints
    // Serialize message field [joint_constraints]
    // Serialize the length for message field [joint_constraints]
    bufferOffset = _serializer.uint32(obj.joint_constraints.length, buffer, bufferOffset);
    obj.joint_constraints.forEach((val) => {
      bufferOffset = JointConstraint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [position_constraints]
    // Serialize the length for message field [position_constraints]
    bufferOffset = _serializer.uint32(obj.position_constraints.length, buffer, bufferOffset);
    obj.position_constraints.forEach((val) => {
      bufferOffset = PositionConstraint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [orientation_constraints]
    // Serialize the length for message field [orientation_constraints]
    bufferOffset = _serializer.uint32(obj.orientation_constraints.length, buffer, bufferOffset);
    obj.orientation_constraints.forEach((val) => {
      bufferOffset = OrientationConstraint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [visibility_constraints]
    // Serialize the length for message field [visibility_constraints]
    bufferOffset = _serializer.uint32(obj.visibility_constraints.length, buffer, bufferOffset);
    obj.visibility_constraints.forEach((val) => {
      bufferOffset = VisibilityConstraint.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Constraints
    let len;
    let data = new Constraints(null);
    // Deserialize message field [joint_constraints]
    // Deserialize array length for message field [joint_constraints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.joint_constraints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.joint_constraints[i] = JointConstraint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [position_constraints]
    // Deserialize array length for message field [position_constraints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.position_constraints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.position_constraints[i] = PositionConstraint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [orientation_constraints]
    // Deserialize array length for message field [orientation_constraints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.orientation_constraints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.orientation_constraints[i] = OrientationConstraint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [visibility_constraints]
    // Deserialize array length for message field [visibility_constraints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.visibility_constraints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.visibility_constraints[i] = VisibilityConstraint.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.joint_constraints.forEach((val) => {
      length += JointConstraint.getMessageSize(val);
    });
    object.position_constraints.forEach((val) => {
      length += PositionConstraint.getMessageSize(val);
    });
    object.orientation_constraints.forEach((val) => {
      length += OrientationConstraint.getMessageSize(val);
    });
    object.visibility_constraints.forEach((val) => {
      length += VisibilityConstraint.getMessageSize(val);
    });
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/Constraints';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'fe6b6f09c687fd46c05a2de4ca18378a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message contains a list of motion planning constraints.
    
    arm_navigation_msgs/JointConstraint[] joint_constraints
    arm_navigation_msgs/PositionConstraint[] position_constraints
    arm_navigation_msgs/OrientationConstraint[] orientation_constraints
    arm_navigation_msgs/VisibilityConstraint[] visibility_constraints
    
    ================================================================================
    MSG: arm_navigation_msgs/JointConstraint
    # Constrain the position of a joint to be within a certain bound
    string joint_name
    
    # the bound to be achieved is [position - tolerance_below, position + tolerance_above]
    float64 position
    float64 tolerance_above
    float64 tolerance_below
    
    # A weighting factor for this constraint
    float64 weight
    ================================================================================
    MSG: arm_navigation_msgs/PositionConstraint
    # This message contains the definition of a position constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The offset (in the link frame) for the target point on the link we are planning for
    geometry_msgs/Point target_point_offset
    
    # The nominal/target position for the point we are planning for
    geometry_msgs/Point position
    
    # The shape of the bounded region that constrains the position of the end-effector
    # This region is always centered at the position defined above
    arm_navigation_msgs/Shape constraint_region_shape
    
    # The orientation of the bounded region that constrains the position of the end-effector. 
    # This allows the specification of non-axis aligned constraints
    geometry_msgs/Quaternion constraint_region_orientation
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/OrientationConstraint
    # This message contains the definition of an orientation constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The type of the constraint
    int32 type
    int32 LINK_FRAME=0
    int32 HEADER_FRAME=1
    
    # The desired orientation of the robot link specified as a quaternion
    geometry_msgs/Quaternion orientation
    
    # optional RPY error tolerances specified if 
    float64 absolute_roll_tolerance
    float64 absolute_pitch_tolerance
    float64 absolute_yaw_tolerance
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/VisibilityConstraint
    # This message contains the definition of a visibility constraint.
    Header header
    
    # The point stamped target that needs to be kept within view of the sensor
    geometry_msgs/PointStamped target
    
    # The local pose of the frame in which visibility is to be maintained
    # The frame id should represent the robot link to which the sensor is attached
    # The visual axis of the sensor is assumed to be along the X axis of this frame
    geometry_msgs/PoseStamped sensor_pose
    
    # The deviation (in radians) that will be tolerated
    # Constraint error will be measured as the solid angle between the 
    # X axis of the frame defined above and the vector between the origin 
    # of the frame defined above and the target location
    float64 absolute_tolerance
    
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Constraints(null);
    if (msg.joint_constraints !== undefined) {
      resolved.joint_constraints = new Array(msg.joint_constraints.length);
      for (let i = 0; i < resolved.joint_constraints.length; ++i) {
        resolved.joint_constraints[i] = JointConstraint.Resolve(msg.joint_constraints[i]);
      }
    }
    else {
      resolved.joint_constraints = []
    }

    if (msg.position_constraints !== undefined) {
      resolved.position_constraints = new Array(msg.position_constraints.length);
      for (let i = 0; i < resolved.position_constraints.length; ++i) {
        resolved.position_constraints[i] = PositionConstraint.Resolve(msg.position_constraints[i]);
      }
    }
    else {
      resolved.position_constraints = []
    }

    if (msg.orientation_constraints !== undefined) {
      resolved.orientation_constraints = new Array(msg.orientation_constraints.length);
      for (let i = 0; i < resolved.orientation_constraints.length; ++i) {
        resolved.orientation_constraints[i] = OrientationConstraint.Resolve(msg.orientation_constraints[i]);
      }
    }
    else {
      resolved.orientation_constraints = []
    }

    if (msg.visibility_constraints !== undefined) {
      resolved.visibility_constraints = new Array(msg.visibility_constraints.length);
      for (let i = 0; i < resolved.visibility_constraints.length; ++i) {
        resolved.visibility_constraints[i] = VisibilityConstraint.Resolve(msg.visibility_constraints[i]);
      }
    }
    else {
      resolved.visibility_constraints = []
    }

    return resolved;
    }
};

module.exports = Constraints;
