// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Shape = require('./Shape.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class PositionConstraint {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.link_name = null;
      this.target_point_offset = null;
      this.position = null;
      this.constraint_region_shape = null;
      this.constraint_region_orientation = null;
      this.weight = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('link_name')) {
        this.link_name = initObj.link_name
      }
      else {
        this.link_name = '';
      }
      if (initObj.hasOwnProperty('target_point_offset')) {
        this.target_point_offset = initObj.target_point_offset
      }
      else {
        this.target_point_offset = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('position')) {
        this.position = initObj.position
      }
      else {
        this.position = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('constraint_region_shape')) {
        this.constraint_region_shape = initObj.constraint_region_shape
      }
      else {
        this.constraint_region_shape = new Shape();
      }
      if (initObj.hasOwnProperty('constraint_region_orientation')) {
        this.constraint_region_orientation = initObj.constraint_region_orientation
      }
      else {
        this.constraint_region_orientation = new geometry_msgs.msg.Quaternion();
      }
      if (initObj.hasOwnProperty('weight')) {
        this.weight = initObj.weight
      }
      else {
        this.weight = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PositionConstraint
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [link_name]
    bufferOffset = _serializer.string(obj.link_name, buffer, bufferOffset);
    // Serialize message field [target_point_offset]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.target_point_offset, buffer, bufferOffset);
    // Serialize message field [position]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.position, buffer, bufferOffset);
    // Serialize message field [constraint_region_shape]
    bufferOffset = Shape.serialize(obj.constraint_region_shape, buffer, bufferOffset);
    // Serialize message field [constraint_region_orientation]
    bufferOffset = geometry_msgs.msg.Quaternion.serialize(obj.constraint_region_orientation, buffer, bufferOffset);
    // Serialize message field [weight]
    bufferOffset = _serializer.float64(obj.weight, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PositionConstraint
    let len;
    let data = new PositionConstraint(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [link_name]
    data.link_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [target_point_offset]
    data.target_point_offset = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [position]
    data.position = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [constraint_region_shape]
    data.constraint_region_shape = Shape.deserialize(buffer, bufferOffset);
    // Deserialize message field [constraint_region_orientation]
    data.constraint_region_orientation = geometry_msgs.msg.Quaternion.deserialize(buffer, bufferOffset);
    // Deserialize message field [weight]
    data.weight = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += object.link_name.length;
    length += Shape.getMessageSize(object.constraint_region_shape);
    return length + 92;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/PositionConstraint';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7e3d9697e64b346b9d3cb7311bb88ccb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message contains the definition of a position constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The offset (in the link frame) for the target point on the link we are planning for
    geometry_msgs/Point target_point_offset
    
    # The nominal/target position for the point we are planning for
    geometry_msgs/Point position
    
    # The shape of the bounded region that constrains the position of the end-effector
    # This region is always centered at the position defined above
    arm_navigation_msgs/Shape constraint_region_shape
    
    # The orientation of the bounded region that constrains the position of the end-effector. 
    # This allows the specification of non-axis aligned constraints
    geometry_msgs/Quaternion constraint_region_orientation
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PositionConstraint(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.link_name !== undefined) {
      resolved.link_name = msg.link_name;
    }
    else {
      resolved.link_name = ''
    }

    if (msg.target_point_offset !== undefined) {
      resolved.target_point_offset = geometry_msgs.msg.Point.Resolve(msg.target_point_offset)
    }
    else {
      resolved.target_point_offset = new geometry_msgs.msg.Point()
    }

    if (msg.position !== undefined) {
      resolved.position = geometry_msgs.msg.Point.Resolve(msg.position)
    }
    else {
      resolved.position = new geometry_msgs.msg.Point()
    }

    if (msg.constraint_region_shape !== undefined) {
      resolved.constraint_region_shape = Shape.Resolve(msg.constraint_region_shape)
    }
    else {
      resolved.constraint_region_shape = new Shape()
    }

    if (msg.constraint_region_orientation !== undefined) {
      resolved.constraint_region_orientation = geometry_msgs.msg.Quaternion.Resolve(msg.constraint_region_orientation)
    }
    else {
      resolved.constraint_region_orientation = new geometry_msgs.msg.Quaternion()
    }

    if (msg.weight !== undefined) {
      resolved.weight = msg.weight;
    }
    else {
      resolved.weight = 0.0
    }

    return resolved;
    }
};

module.exports = PositionConstraint;
