// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class VisibilityConstraint {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.target = null;
      this.sensor_pose = null;
      this.absolute_tolerance = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('target')) {
        this.target = initObj.target
      }
      else {
        this.target = new geometry_msgs.msg.PointStamped();
      }
      if (initObj.hasOwnProperty('sensor_pose')) {
        this.sensor_pose = initObj.sensor_pose
      }
      else {
        this.sensor_pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('absolute_tolerance')) {
        this.absolute_tolerance = initObj.absolute_tolerance
      }
      else {
        this.absolute_tolerance = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VisibilityConstraint
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [target]
    bufferOffset = geometry_msgs.msg.PointStamped.serialize(obj.target, buffer, bufferOffset);
    // Serialize message field [sensor_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.sensor_pose, buffer, bufferOffset);
    // Serialize message field [absolute_tolerance]
    bufferOffset = _serializer.float64(obj.absolute_tolerance, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VisibilityConstraint
    let len;
    let data = new VisibilityConstraint(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [target]
    data.target = geometry_msgs.msg.PointStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [sensor_pose]
    data.sensor_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [absolute_tolerance]
    data.absolute_tolerance = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += geometry_msgs.msg.PointStamped.getMessageSize(object.target);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.sensor_pose);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/VisibilityConstraint';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ab297b6588ea21c1a862067d8447cb08';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message contains the definition of a visibility constraint.
    Header header
    
    # The point stamped target that needs to be kept within view of the sensor
    geometry_msgs/PointStamped target
    
    # The local pose of the frame in which visibility is to be maintained
    # The frame id should represent the robot link to which the sensor is attached
    # The visual axis of the sensor is assumed to be along the X axis of this frame
    geometry_msgs/PoseStamped sensor_pose
    
    # The deviation (in radians) that will be tolerated
    # Constraint error will be measured as the solid angle between the 
    # X axis of the frame defined above and the vector between the origin 
    # of the frame defined above and the target location
    float64 absolute_tolerance
    
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VisibilityConstraint(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.target !== undefined) {
      resolved.target = geometry_msgs.msg.PointStamped.Resolve(msg.target)
    }
    else {
      resolved.target = new geometry_msgs.msg.PointStamped()
    }

    if (msg.sensor_pose !== undefined) {
      resolved.sensor_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.sensor_pose)
    }
    else {
      resolved.sensor_pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.absolute_tolerance !== undefined) {
      resolved.absolute_tolerance = msg.absolute_tolerance;
    }
    else {
      resolved.absolute_tolerance = 0.0
    }

    return resolved;
    }
};

module.exports = VisibilityConstraint;
