// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Shape = require('./Shape.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class WorkspaceParameters {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.workspace_region_shape = null;
      this.workspace_region_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('workspace_region_shape')) {
        this.workspace_region_shape = initObj.workspace_region_shape
      }
      else {
        this.workspace_region_shape = new Shape();
      }
      if (initObj.hasOwnProperty('workspace_region_pose')) {
        this.workspace_region_pose = initObj.workspace_region_pose
      }
      else {
        this.workspace_region_pose = new geometry_msgs.msg.PoseStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WorkspaceParameters
    // Serialize message field [workspace_region_shape]
    bufferOffset = Shape.serialize(obj.workspace_region_shape, buffer, bufferOffset);
    // Serialize message field [workspace_region_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.workspace_region_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WorkspaceParameters
    let len;
    let data = new WorkspaceParameters(null);
    // Deserialize message field [workspace_region_shape]
    data.workspace_region_shape = Shape.deserialize(buffer, bufferOffset);
    // Deserialize message field [workspace_region_pose]
    data.workspace_region_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Shape.getMessageSize(object.workspace_region_shape);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.workspace_region_pose);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/WorkspaceParameters';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1487490edff0df276863abf2cf221de5';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message contains a set of parameters useful in
    # setting up the workspace for planning
    arm_navigation_msgs/Shape  workspace_region_shape
    geometry_msgs/PoseStamped    workspace_region_pose
    
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WorkspaceParameters(null);
    if (msg.workspace_region_shape !== undefined) {
      resolved.workspace_region_shape = Shape.Resolve(msg.workspace_region_shape)
    }
    else {
      resolved.workspace_region_shape = new Shape()
    }

    if (msg.workspace_region_pose !== undefined) {
      resolved.workspace_region_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.workspace_region_pose)
    }
    else {
      resolved.workspace_region_pose = new geometry_msgs.msg.PoseStamped()
    }

    return resolved;
    }
};

module.exports = WorkspaceParameters;
