// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RobotState = require('../msg/RobotState.js');
let Constraints = require('../msg/Constraints.js');

//-----------------------------------------------------------

let ArmNavigationErrorCodes = require('../msg/ArmNavigationErrorCodes.js');
let ContactInformation = require('../msg/ContactInformation.js');

//-----------------------------------------------------------

class GetStateValidityRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.robot_state = null;
      this.check_collisions = null;
      this.check_path_constraints = null;
      this.check_goal_constraints = null;
      this.check_joint_limits = null;
      this.group_name = null;
      this.path_constraints = null;
      this.goal_constraints = null;
    }
    else {
      if (initObj.hasOwnProperty('robot_state')) {
        this.robot_state = initObj.robot_state
      }
      else {
        this.robot_state = new RobotState();
      }
      if (initObj.hasOwnProperty('check_collisions')) {
        this.check_collisions = initObj.check_collisions
      }
      else {
        this.check_collisions = false;
      }
      if (initObj.hasOwnProperty('check_path_constraints')) {
        this.check_path_constraints = initObj.check_path_constraints
      }
      else {
        this.check_path_constraints = false;
      }
      if (initObj.hasOwnProperty('check_goal_constraints')) {
        this.check_goal_constraints = initObj.check_goal_constraints
      }
      else {
        this.check_goal_constraints = false;
      }
      if (initObj.hasOwnProperty('check_joint_limits')) {
        this.check_joint_limits = initObj.check_joint_limits
      }
      else {
        this.check_joint_limits = false;
      }
      if (initObj.hasOwnProperty('group_name')) {
        this.group_name = initObj.group_name
      }
      else {
        this.group_name = '';
      }
      if (initObj.hasOwnProperty('path_constraints')) {
        this.path_constraints = initObj.path_constraints
      }
      else {
        this.path_constraints = new Constraints();
      }
      if (initObj.hasOwnProperty('goal_constraints')) {
        this.goal_constraints = initObj.goal_constraints
      }
      else {
        this.goal_constraints = new Constraints();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetStateValidityRequest
    // Serialize message field [robot_state]
    bufferOffset = RobotState.serialize(obj.robot_state, buffer, bufferOffset);
    // Serialize message field [check_collisions]
    bufferOffset = _serializer.bool(obj.check_collisions, buffer, bufferOffset);
    // Serialize message field [check_path_constraints]
    bufferOffset = _serializer.bool(obj.check_path_constraints, buffer, bufferOffset);
    // Serialize message field [check_goal_constraints]
    bufferOffset = _serializer.bool(obj.check_goal_constraints, buffer, bufferOffset);
    // Serialize message field [check_joint_limits]
    bufferOffset = _serializer.bool(obj.check_joint_limits, buffer, bufferOffset);
    // Serialize message field [group_name]
    bufferOffset = _serializer.string(obj.group_name, buffer, bufferOffset);
    // Serialize message field [path_constraints]
    bufferOffset = Constraints.serialize(obj.path_constraints, buffer, bufferOffset);
    // Serialize message field [goal_constraints]
    bufferOffset = Constraints.serialize(obj.goal_constraints, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetStateValidityRequest
    let len;
    let data = new GetStateValidityRequest(null);
    // Deserialize message field [robot_state]
    data.robot_state = RobotState.deserialize(buffer, bufferOffset);
    // Deserialize message field [check_collisions]
    data.check_collisions = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [check_path_constraints]
    data.check_path_constraints = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [check_goal_constraints]
    data.check_goal_constraints = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [check_joint_limits]
    data.check_joint_limits = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [group_name]
    data.group_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [path_constraints]
    data.path_constraints = Constraints.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal_constraints]
    data.goal_constraints = Constraints.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += RobotState.getMessageSize(object.robot_state);
    length += object.group_name.length;
    length += Constraints.getMessageSize(object.path_constraints);
    length += Constraints.getMessageSize(object.goal_constraints);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetStateValidityRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'fe05d730cc03ecb8a8dff34774a12c59';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    arm_navigation_msgs/RobotState robot_state
    
    
    bool check_collisions
    
    
    bool check_path_constraints
    
    
    bool check_goal_constraints
    
    
    bool check_joint_limits
    
    
    string group_name
    
    
    
    
    arm_navigation_msgs/Constraints path_constraints
    
    
    
    
    arm_navigation_msgs/Constraints goal_constraints
    
    
    ================================================================================
    MSG: arm_navigation_msgs/RobotState
    # This message contains information about the robot state, i.e. the positions of its joints and links
    sensor_msgs/JointState joint_state
    arm_navigation_msgs/MultiDOFJointState multi_dof_joint_state
    
    ================================================================================
    MSG: sensor_msgs/JointState
    # This is a message that holds data to describe the state of a set of torque controlled joints. 
    #
    # The state of each joint (revolute or prismatic) is defined by:
    #  * the position of the joint (rad or m),
    #  * the velocity of the joint (rad/s or m/s) and 
    #  * the effort that is applied in the joint (Nm or N).
    #
    # Each joint is uniquely identified by its name
    # The header specifies the time at which the joint states were recorded. All the joint states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the joint state. 
    # The goal is to make each of the fields optional. When e.g. your joints have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    
    Header header
    
    string[] name
    float64[] position
    float64[] velocity
    float64[] effort
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointState
    #A representation of a multi-dof joint state
    time stamp
    string[] joint_names
    string[] frame_ids
    string[] child_frame_ids
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/Constraints
    # This message contains a list of motion planning constraints.
    
    arm_navigation_msgs/JointConstraint[] joint_constraints
    arm_navigation_msgs/PositionConstraint[] position_constraints
    arm_navigation_msgs/OrientationConstraint[] orientation_constraints
    arm_navigation_msgs/VisibilityConstraint[] visibility_constraints
    
    ================================================================================
    MSG: arm_navigation_msgs/JointConstraint
    # Constrain the position of a joint to be within a certain bound
    string joint_name
    
    # the bound to be achieved is [position - tolerance_below, position + tolerance_above]
    float64 position
    float64 tolerance_above
    float64 tolerance_below
    
    # A weighting factor for this constraint
    float64 weight
    ================================================================================
    MSG: arm_navigation_msgs/PositionConstraint
    # This message contains the definition of a position constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The offset (in the link frame) for the target point on the link we are planning for
    geometry_msgs/Point target_point_offset
    
    # The nominal/target position for the point we are planning for
    geometry_msgs/Point position
    
    # The shape of the bounded region that constrains the position of the end-effector
    # This region is always centered at the position defined above
    arm_navigation_msgs/Shape constraint_region_shape
    
    # The orientation of the bounded region that constrains the position of the end-effector. 
    # This allows the specification of non-axis aligned constraints
    geometry_msgs/Quaternion constraint_region_orientation
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: arm_navigation_msgs/OrientationConstraint
    # This message contains the definition of an orientation constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The type of the constraint
    int32 type
    int32 LINK_FRAME=0
    int32 HEADER_FRAME=1
    
    # The desired orientation of the robot link specified as a quaternion
    geometry_msgs/Quaternion orientation
    
    # optional RPY error tolerances specified if 
    float64 absolute_roll_tolerance
    float64 absolute_pitch_tolerance
    float64 absolute_yaw_tolerance
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/VisibilityConstraint
    # This message contains the definition of a visibility constraint.
    Header header
    
    # The point stamped target that needs to be kept within view of the sensor
    geometry_msgs/PointStamped target
    
    # The local pose of the frame in which visibility is to be maintained
    # The frame id should represent the robot link to which the sensor is attached
    # The visual axis of the sensor is assumed to be along the X axis of this frame
    geometry_msgs/PoseStamped sensor_pose
    
    # The deviation (in radians) that will be tolerated
    # Constraint error will be measured as the solid angle between the 
    # X axis of the frame defined above and the vector between the origin 
    # of the frame defined above and the target location
    float64 absolute_tolerance
    
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetStateValidityRequest(null);
    if (msg.robot_state !== undefined) {
      resolved.robot_state = RobotState.Resolve(msg.robot_state)
    }
    else {
      resolved.robot_state = new RobotState()
    }

    if (msg.check_collisions !== undefined) {
      resolved.check_collisions = msg.check_collisions;
    }
    else {
      resolved.check_collisions = false
    }

    if (msg.check_path_constraints !== undefined) {
      resolved.check_path_constraints = msg.check_path_constraints;
    }
    else {
      resolved.check_path_constraints = false
    }

    if (msg.check_goal_constraints !== undefined) {
      resolved.check_goal_constraints = msg.check_goal_constraints;
    }
    else {
      resolved.check_goal_constraints = false
    }

    if (msg.check_joint_limits !== undefined) {
      resolved.check_joint_limits = msg.check_joint_limits;
    }
    else {
      resolved.check_joint_limits = false
    }

    if (msg.group_name !== undefined) {
      resolved.group_name = msg.group_name;
    }
    else {
      resolved.group_name = ''
    }

    if (msg.path_constraints !== undefined) {
      resolved.path_constraints = Constraints.Resolve(msg.path_constraints)
    }
    else {
      resolved.path_constraints = new Constraints()
    }

    if (msg.goal_constraints !== undefined) {
      resolved.goal_constraints = Constraints.Resolve(msg.goal_constraints)
    }
    else {
      resolved.goal_constraints = new Constraints()
    }

    return resolved;
    }
};

class GetStateValidityResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.error_code = null;
      this.contacts = null;
    }
    else {
      if (initObj.hasOwnProperty('error_code')) {
        this.error_code = initObj.error_code
      }
      else {
        this.error_code = new ArmNavigationErrorCodes();
      }
      if (initObj.hasOwnProperty('contacts')) {
        this.contacts = initObj.contacts
      }
      else {
        this.contacts = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetStateValidityResponse
    // Serialize message field [error_code]
    bufferOffset = ArmNavigationErrorCodes.serialize(obj.error_code, buffer, bufferOffset);
    // Serialize message field [contacts]
    // Serialize the length for message field [contacts]
    bufferOffset = _serializer.uint32(obj.contacts.length, buffer, bufferOffset);
    obj.contacts.forEach((val) => {
      bufferOffset = ContactInformation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetStateValidityResponse
    let len;
    let data = new GetStateValidityResponse(null);
    // Deserialize message field [error_code]
    data.error_code = ArmNavigationErrorCodes.deserialize(buffer, bufferOffset);
    // Deserialize message field [contacts]
    // Deserialize array length for message field [contacts]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.contacts = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.contacts[i] = ContactInformation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.contacts.forEach((val) => {
      length += ContactInformation.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetStateValidityResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3229301226a0605e3ffc9dfdaeac662f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    
    arm_navigation_msgs/ArmNavigationErrorCodes error_code
    
    
    arm_navigation_msgs/ContactInformation[] contacts
    
    
    ================================================================================
    MSG: arm_navigation_msgs/ArmNavigationErrorCodes
    int32 val
    
    # overall behavior
    int32 PLANNING_FAILED=-1
    int32 SUCCESS=1
    int32 TIMED_OUT=-2
    
    # start state errors
    int32 START_STATE_IN_COLLISION=-3
    int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4
    
    # goal errors
    int32 GOAL_IN_COLLISION=-5
    int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6
    
    # robot state
    int32 INVALID_ROBOT_STATE=-7
    int32 INCOMPLETE_ROBOT_STATE=-8
    
    # planning request errors
    int32 INVALID_PLANNER_ID=-9
    int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
    int32 INVALID_ALLOWED_PLANNING_TIME=-11
    int32 INVALID_GROUP_NAME=-12
    int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
    int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
    int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
    int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
    int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
    int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18
    
    # state/trajectory monitor errors
    int32 INVALID_TRAJECTORY=-19
    int32 INVALID_INDEX=-20
    int32 JOINT_LIMITS_VIOLATED=-21
    int32 PATH_CONSTRAINTS_VIOLATED=-22
    int32 COLLISION_CONSTRAINTS_VIOLATED=-23
    int32 GOAL_CONSTRAINTS_VIOLATED=-24
    int32 JOINTS_NOT_MOVING=-25
    int32 TRAJECTORY_CONTROLLER_FAILED=-26
    
    # system errors
    int32 FRAME_TRANSFORM_FAILURE=-27
    int32 COLLISION_CHECKING_UNAVAILABLE=-28
    int32 ROBOT_STATE_STALE=-29
    int32 SENSOR_INFO_STALE=-30
    
    # kinematics errors
    int32 NO_IK_SOLUTION=-31
    int32 INVALID_LINK_NAME=-32
    int32 IK_LINK_IN_COLLISION=-33
    int32 NO_FK_SOLUTION=-34
    int32 KINEMATICS_STATE_IN_COLLISION=-35
    
    # general errors
    int32 INVALID_TIMEOUT=-36
    
    
    ================================================================================
    MSG: arm_navigation_msgs/ContactInformation
    # Standard ROS header contains information 
    # about the frame in which this 
    # contact is specified
    Header header
    
    # Position of the contact point
    geometry_msgs/Point position
    
    # Normal corresponding to the contact point
    geometry_msgs/Vector3 normal 
    
    # Depth of contact point
    float64 depth
    
    # Name of the first body that is in contact
    # This could be a link or a namespace that represents a body
    string contact_body_1
    string attached_body_1
    uint32 body_type_1
    
    # Name of the second body that is in contact
    # This could be a link or a namespace that represents a body
    string contact_body_2
    string attached_body_2
    uint32 body_type_2
    
    uint32 ROBOT_LINK=0
    uint32 OBJECT=1
    uint32 ATTACHED_BODY=2
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetStateValidityResponse(null);
    if (msg.error_code !== undefined) {
      resolved.error_code = ArmNavigationErrorCodes.Resolve(msg.error_code)
    }
    else {
      resolved.error_code = new ArmNavigationErrorCodes()
    }

    if (msg.contacts !== undefined) {
      resolved.contacts = new Array(msg.contacts.length);
      for (let i = 0; i < resolved.contacts.length; ++i) {
        resolved.contacts[i] = ContactInformation.Resolve(msg.contacts[i]);
      }
    }
    else {
      resolved.contacts = []
    }

    return resolved;
    }
};

module.exports = {
  Request: GetStateValidityRequest,
  Response: GetStateValidityResponse,
  md5sum() { return '05125b9572f64feb9a7f590a8674e9ee'; },
  datatype() { return 'arm_navigation_msgs/GetStateValidity'; }
};
